function [Offset3, Index, Data] = ArrayToSparseMatrixconversion(A)
TT = size(A,1);
C = size(A,2);
E = size(A,3);
N = size(A{1,1,1},1);
D = size(A{1,1,1},2);

Offset1 = uint32(0);
Offset2 = uint32(0);
Offset3 = uint32(0);
Index = uint32(ones(1,2));

offset1_cnt = uint32(1);
offset2_cnt = uint32(1);
offset3_cnt = uint32(1);
data_cnt = uint32(0);

for tt = 1:1:TT
    TT
    tt
    Offset1(offset1_cnt) = offset2_cnt;
    offset1_cnt = offset1_cnt + 1;            
    
    for c = 1:1:C
        Offset2(offset2_cnt) = offset3_cnt;
        offset2_cnt = offset2_cnt + 1;            
        
        for e = 1:1:E
            Offset3(offset3_cnt) = data_cnt + 1;
            offset3_cnt = offset3_cnt + 1;            
            
            TMP = full(A{tt,c,e});

            [row,col,v] = find(TMP);
            if((size(row,1) > 0) && (size(row,2) > 0))
                Index(1,data_cnt+1:data_cnt+size(v,1)) = uint32(row);
                Index(2,data_cnt+1:data_cnt+size(v,1)) = uint32(col);
                Data(data_cnt+1:data_cnt+size(v,1)) = v;
                data_cnt = data_cnt + size(v,1);
            end
        end        
    end    
end

Offset3(offset3_cnt) = data_cnt + 1;
Offset2(offset2_cnt) = offset3_cnt;
Offset1(offset1_cnt) = offset2_cnt;
% 
% B=cell(TT, C, E);
% for tt = 1:1:TT;
%     for c = 1:1:C
%         for e = 1:1:E
%             offset_cnt = e + (E * ((c-1) + (C * (tt-1))))
%             
%             B{tt,c,e} = sparse(N,D);   
%             [Offset3(offset_cnt), Offset3(offset_cnt+1)]
%             if(Offset3(offset_cnt+1) > Offset3(offset_cnt))
%                 for i=Offset3(offset_cnt):1:(Offset3(offset_cnt+1)-1)
%                     B{tt,c,e}(Index(1,i), Index(2,i)) = Data(i);
%                 end
%             end
%             [tt,c,e]            
%             B{tt,c,e} - A{tt,c,e}
%         end
%     end
% end
